diff --git a/tests/Feature/Http/Controllers/Api/Auth/Password/ResetControllerTest.php b/tests/Feature/Http/Controllers/Api/Auth/Password/ResetControllerTest.php
index b12fc4e..ae9cdca 100644
--- a/tests/Feature/Http/Controllers/Api/Auth/Password/ResetControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/Auth/Password/ResetControllerTest.php
@@ -7,13 +7,10 @@ use DB;
 use Hash;
 use Illuminate\Support\Str;
 use Tests\Feature\ApiTestCase;
-use Tests\MailTrap;
 use Portal\User;
 
 class ResetControllerTest extends ApiTestCase
 {
-    use MailTrap;
-
     public function test_password_reset()
     {
         $this->setSettings(['forgot_password' => true]);
diff --git a/tests/Feature/Http/Controllers/Api/Auth/RegistrationControllerTest.php b/tests/Feature/Http/Controllers/Api/Auth/RegistrationControllerTest.php
index eefbf25..0901dda 100644
--- a/tests/Feature/Http/Controllers/Api/Auth/RegistrationControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/Auth/RegistrationControllerTest.php
@@ -2,14 +2,13 @@
 
 namespace Tests\Feature\Http\Controllers\Api\Auth;
 
+use Illuminate\Support\Facades\Notification;
 use Tests\Feature\ApiTestCase;
-use Tests\MailTrap;
+use Portal\Notifications\EmailConfirmation;
 use Portal\User;
 
 class RegistrationControllerTest extends ApiTestCase
 {
-    use MailTrap;
-
     public function test_register_user_when_registration_is_disabled()
     {
         $this->setSettings([
@@ -57,6 +56,8 @@ class RegistrationControllerTest extends ApiTestCase
             'tos' => false
         ]);
 
+        Notification::fake();
+
         $data = [
             'email' => 'john.doe@test.com',
             'username' => 'john.doe',
@@ -69,32 +70,28 @@ class RegistrationControllerTest extends ApiTestCase
         $expected = array_except($data, ['password', 'password_confirmation']);
 
         $this->seeStatusCode(201)
-            ->seeJson([
-                'requires_email_confirmation' => true
-            ])
+            ->seeJson(['requires_email_confirmation' => true])
             ->seeInDatabase('users', $expected);
 
-        $token = User::where('email', $data['email'])->first()->confirmation_token;
+        $user = User::where('email', $data['email'])->first();
 
-        $message = $this->fetchInbox()[0];
+        Notification::assertSentTo(
+            $user,
+            EmailConfirmation::class,
+            function ($notification, $channels) use ($user) {
+                $mail = $notification->toMail()->toArray();
 
-        $this->assertEquals($data['email'], $message['to_email']);
-        $this->assertEquals(config('mail.from.address'), $message['from_email']);
-        $this->assertEquals(config('mail.from.name'), $message['from_name']);
-        $this->assertContains(
-            trans('app.thank_you_for_registering', ['app' => settings('app_name')]),
-            trim($message['html_body'])
-        );
-        $this->assertContains(
-            trans('app.confirm_email_on_link_below'),
-            trim($message['html_body'])
-        );
-        $this->assertContains(
-            route('register.confirm-email', $token),
-            trim($message['html_body'])
-        );
+                $this->assertContains(
+                    trans('app.thank_you_for_registering', ['app' => settings('app_name')]),
+                    $mail['introLines']
+                );
 
-        $this->emptyInbox();
+                $this->assertContains(trans('app.confirm_email_on_link_below'), $mail['introLines']);
+                $this->assertEquals(route('register.confirm-email', $user->confirmation_token), $mail['actionUrl']);
+
+                return true;
+            }
+        );
     }
 
     public function test_register_with_tos()
diff --git a/tests/Feature/Http/Controllers/Api/Profile/TwoFactorControllerTest.php b/tests/Feature/Http/Controllers/Api/Profile/TwoFactorControllerTest.php
index 4d29989..b09d02c 100644
--- a/tests/Feature/Http/Controllers/Api/Profile/TwoFactorControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/Profile/TwoFactorControllerTest.php
@@ -3,8 +3,10 @@
 namespace Tests\Feature\Http\Controllers\Api\Profile;
 
 use Authy;
+use Mockery;
 use Settings;
 use Tests\Feature\ApiTestCase;
+use Portal\Events\User\TwoFactorEnabled;
 use Portal\Transformers\UserTransformer;
 use Portal\User;
 
@@ -28,28 +30,58 @@ class TwoFactorControllerTest extends ApiTestCase
             '2fa.enabled' => true
         ]);
 
+        $this->withoutExceptionHandling();
+
+        $this->doesntExpectEvents(TwoFactorEnabled::class);
+
         $user = $this->login();
 
         Authy::shouldReceive('isEnabled')->andReturn(false);
         Authy::shouldReceive('register')->andReturnNull();
+        Authy::shouldReceive('sendTwoFactorVerificationToken');
 
         $data = ['country_code' => '1', 'phone_number' => '123'];
  
         $this->putJson("api/me/2fa", $data);
 
+        $this->assertResponseOk()
+            ->seeJson(['message' => 'Verification token sent.'])
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => $data['country_code'],
+                'two_factor_phone' => $data['phone_number']
+            ]);
+    }
+
+    /** @test */
+    public function verify_user_phone_with_correct_token()
+    {
+        $this->setSettings([
+            '2fa.enabled' => true
+        ]);
+
+        $this->expectsEvents(TwoFactorEnabled::class);
+
+        $user = $this->login();
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('tokenIsValid')->with(Mockery::any(), '123123')->andReturn(true);
+
+        $this->postJson("api/me/2fa/verify", ['token' => '123123']);
+
         $transformer = new UserTransformer;
         $updatedUser = $transformer->transform($user->fresh());
 
         $this->assertResponseOk()
             ->seeInDatabase('users', [
                 'id' => $user->id,
-                'two_factor_country_code' => $data['country_code'],
-                'two_factor_phone' => $data['phone_number']
+                'two_factor_options' => '{"enabled":true}'
             ])
             ->seeJsonContains($updatedUser);
     }
 
-    public function test_enable_two_factor_auth_when_it_is_already_enabled()
+    /** @test */
+    public function verify_user_phone_with_invalid_token()
     {
         $this->setSettings([
             '2fa.enabled' => true
@@ -57,7 +89,26 @@ class TwoFactorControllerTest extends ApiTestCase
 
         $user = $this->login();
 
-        $this->addPermissionForUser($user, 'users.manage');
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('tokenIsValid')->andReturn(false);
+
+        $this->postJson("api/me/2fa/verify", ['token' => '123123']);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains(['error' => 'Invalid 2FA token.'])
+            ->dontSeeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_options' => '{"enabled":true}'
+            ]);
+    }
+
+    public function test_enable_two_factor_auth_when_it_is_already_enabled()
+    {
+        $this->setSettings([
+            '2fa.enabled' => true
+        ]);
+
+        $user = $this->login();
 
         Authy::shouldReceive('isEnabled')->andReturn(true);
 
@@ -82,8 +133,6 @@ class TwoFactorControllerTest extends ApiTestCase
             'two_factor_phone' => '123'
         ]);
 
-        $this->addPermissionForUser($user, 'users.manage');
-
         $this->be($user, 'api');
 
         Authy::shouldReceive('isEnabled')->andReturn(true);
@@ -106,8 +155,6 @@ class TwoFactorControllerTest extends ApiTestCase
 
         $user = $this->login();
 
-        $this->addPermissionForUser($user, 'users.manage');
-
         Authy::shouldReceive('isEnabled')->andReturn(false);
 
         $this->deleteJson("api/me/2fa");
diff --git a/tests/Feature/Http/Controllers/Api/Users/TwoFactorControllerTest.php b/tests/Feature/Http/Controllers/Api/Users/TwoFactorControllerTest.php
index 46c762a..9d0c033 100644
--- a/tests/Feature/Http/Controllers/Api/Users/TwoFactorControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/Users/TwoFactorControllerTest.php
@@ -3,7 +3,7 @@
 namespace Tests\Feature\Http\Controllers\Api\Users;
 
 use Authy;
-use Settings;
+use Mockery;
 use Tests\Feature\ApiTestCase;
 use Portal\Events\User\TwoFactorDisabledByAdmin;
 use Portal\Events\User\TwoFactorEnabledByAdmin;
@@ -43,7 +43,9 @@ class TwoFactorControllerTest extends ApiTestCase
             '2fa.enabled' => true
         ]);
 
-        $this->expectsEvents(TwoFactorEnabledByAdmin::class);
+        $this->withoutExceptionHandling();
+
+        $this->doesntExpectEvents(TwoFactorEnabledByAdmin::class);
 
         $user = $this->login();
 
@@ -51,23 +53,76 @@ class TwoFactorControllerTest extends ApiTestCase
 
         Authy::shouldReceive('isEnabled')->andReturn(false);
         Authy::shouldReceive('register')->andReturnNull();
+        Authy::shouldReceive('sendTwoFactorVerificationToken');
 
         $data = ['country_code' => '1', 'phone_number' => '123'];
  
         $this->putJson("api/users/{$user->id}/2fa", $data);
 
+        $this->assertResponseOk()
+            ->seeJson(['message' => 'Verification token sent.'])
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => $data['country_code'],
+                'two_factor_phone' => $data['phone_number']
+            ]);
+    }
+
+    /** @test */
+    public function verify_user_phone_with_correct_token()
+    {
+        $this->setSettings([
+            '2fa.enabled' => true
+        ]);
+
+        $this->expectsEvents(TwoFactorEnabledByAdmin::class);
+
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('tokenIsValid')->with(Mockery::any(), '123123')->andReturn(true);
+
+        $this->postJson("api/users/{$user->id}/2fa/verify", ['token' => '123123']);
+
         $transformer = new UserTransformer;
         $updatedUser = $transformer->transform($user->fresh());
 
         $this->assertResponseOk()
             ->seeInDatabase('users', [
                 'id' => $user->id,
-                'two_factor_country_code' => $data['country_code'],
-                'two_factor_phone' => $data['phone_number']
+                'two_factor_options' => '{"enabled":true}'
             ])
             ->seeJsonContains($updatedUser);
     }
 
+    /** @test */
+    public function verify_user_phone_with_invalid_token()
+    {
+        $this->setSettings([
+            '2fa.enabled' => true
+        ]);
+
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('tokenIsValid')->andReturn(false);
+
+        $this->postJson("api/users/{$user->id}/2fa/verify", ['token' => '123123']);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'error' => 'Invalid 2FA token.'
+            ])
+            ->dontSeeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_options' => '{"enabled":true}'
+            ]);
+    }
+
     public function test_enable_two_factor_auth_for_user_when_it_is_already_enabled()
     {
         $this->setSettings([
diff --git a/tests/Feature/Http/Controllers/Api/Users/UsersControllerTest.php b/tests/Feature/Http/Controllers/Api/Users/UsersControllerTest.php
index 21f7fc7..842d16f 100644
--- a/tests/Feature/Http/Controllers/Api/Users/UsersControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/Users/UsersControllerTest.php
@@ -2,16 +2,12 @@
 
 namespace Tests\Feature\Http\Controllers\Api\Users;
 
-use Carbon\Carbon;
-use Illuminate\Support\Collection;
 use Tests\Feature\ApiTestCase;
-use Tests\Feature\FunctionalTestCase;
 use Portal\Country;
 use Portal\Events\User\Deleted;
 use Portal\Events\User\UpdatedByAdmin;
 use Portal\Role;
 use Portal\Support\Enum\UserStatus;
-use Portal\Transformers\SessionTransformer;
 use Portal\Transformers\UserTransformer;
 use Portal\User;
 
@@ -61,17 +57,36 @@ class UsersControllerTest extends ApiTestCase
         ]);
     }
 
-    public function test_paginate_users_with_status()
+    /** @test */
+    public function paginate_users_with_country_included()
     {
-        $user = $this->login();
+        $this->login();
 
-        $activeUsers = factory(User::class)->times(2)->create([
-            'status' => UserStatus::ACTIVE
-        ]);
+        $country = factory(Country::class)->create();
 
-        $bannedUsers = factory(User::class)->times(5)->create([
-            'status' => UserStatus::BANNED
-        ]);
+        factory(User::class)->create(['country_id' => null]);
+        factory(User::class)->create(['country_id' => $country->id]);
+
+        $this->getJson('/api/users?include=country');
+
+        $this->assertResponseOk();
+
+        $response = $this->decodeResponseJson();
+
+        $this->assertNotNull($response['data'][0]['country']['id']);
+
+        $this->assertNull($response['data'][1]['country_id']);
+        $this->assertArrayNotHasKey('country', $response['data'][1]);
+
+        $this->assertNotNull($response['data'][2]['country']['id']);
+    }
+
+    public function test_paginate_users_by_status()
+    {
+        $this->login();
+
+        factory(User::class)->times(2)->create(['status' => UserStatus::ACTIVE]);
+        factory(User::class)->times(5)->create(['status' => UserStatus::BANNED]);
 
         $this->getJson('/api/users?status=' . UserStatus::BANNED);
 
diff --git a/tests/Feature/Http/Controllers/Web/Auth/AuthControllerTest.php b/tests/Feature/Http/Controllers/Web/Auth/AuthControllerTest.php
index 9b91ab8..7919caf 100644
--- a/tests/Feature/Http/Controllers/Web/Auth/AuthControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/Auth/AuthControllerTest.php
@@ -7,18 +7,17 @@ use Carbon\Carbon;
 use Mockery;
 use Settings;
 use Tests\Feature\FunctionalTestCase;
-use Tests\MailTrap;
 use Portal\Events\User\LoggedIn;
-use Portal\Events\User\Registered;
+use Portal\Notifications\EmailConfirmation;
+use Portal\Notifications\UserRegistered;
 use Portal\Role;
 use Portal\Support\Enum\UserStatus;
 use Portal\User;
+use Illuminate\Support\Facades\Notification;
 use Mockery as m;
 
 class AuthControllerTest extends FunctionalTestCase
 {
-    use MailTrap;
-
     public function test_login()
     {
         factory(User::class)->create(['username' => 'foo', 'password' => 'bar']);
@@ -171,6 +170,8 @@ class AuthControllerTest extends FunctionalTestCase
             'tos' => true
         ]);
 
+        Notification::fake();
+
         $data = $this->getRegistrationFormStubData();
 
         $this->registerUser($data);
@@ -182,27 +183,25 @@ class AuthControllerTest extends FunctionalTestCase
             ->see('You account is created successfully! Please confirm your email in order to log in.')
             ->seeInDatabase('users', $expected);
 
-        $token = User::where('email', $data['email'])->first()->confirmation_token;
+        $user = User::where('email', $data['email'])->first();
 
-        $message = $this->fetchInbox()[0];
+        Notification::assertSentTo(
+            $user,
+            EmailConfirmation::class,
+            function ($notification, $channels) use ($user) {
+                $mail = $notification->toMail()->toArray();
 
-        $this->assertEquals('test@test.com', $message['to_email']);
-        $this->assertEquals(config('mail.from.address'), $message['from_email']);
-        $this->assertEquals(config('mail.from.name'), $message['from_name']);
-        $this->assertContains(
-            trans('app.thank_you_for_registering', ['app' => settings('app_name')]),
-            trim($message['html_body'])
-        );
-        $this->assertContains(
-            trans('app.confirm_email_on_link_below'),
-            trim($message['html_body'])
-        );
-        $this->assertContains(
-            route('register.confirm-email', $token),
-            trim($message['html_body'])
-        );
+                $this->assertContains(
+                    trans('app.thank_you_for_registering', ['app' => settings('app_name')]),
+                    $mail['introLines']
+                );
 
-        $this->emptyInbox();
+                $this->assertContains(trans('app.confirm_email_on_link_below'), $mail['introLines']);
+                $this->assertEquals(route('register.confirm-email', $user->confirmation_token), $mail['actionUrl']);
+
+                return true;
+            }
+        );
     }
 
     public function test_registration_without_email_confirmation()
@@ -215,7 +214,7 @@ class AuthControllerTest extends FunctionalTestCase
             'tos' => true
         ]);
 
-        $this->expectsEvents(Registered::class);
+        Notification::fake();
 
         $data = $this->getRegistrationFormStubData();
         $this->registerUser($data);
@@ -227,10 +226,13 @@ class AuthControllerTest extends FunctionalTestCase
             ->see('You account is created successfully! You can log in now.')
             ->seeInDatabase('users', $expected);
 
-        $this->assertEmpty($this->fetchInbox());
+        Notification::assertNotSentTo(
+            User::where('email', $data['email'])->first(),
+            EmailConfirmation::class
+        );
     }
 
-    public function test_email_notification_when_new_user_was_registered()
+    public function test_email_notification_is_being_sent_when_new_user_registers()
     {
         $this->setSettings([
             'app_name' => 'foo',
@@ -241,52 +243,38 @@ class AuthControllerTest extends FunctionalTestCase
             'tos' => true
         ]);
 
+        Notification::fake();
+
         $adminRole = Role::where('name', 'Admin')->first();
         $userRole = Role::where('name', 'User')->first();
 
-        $admin1 = factory(User::class)->create([
-            'email' => 'john.doe@test.com',
-            'role_id' => $adminRole->id
-        ]);
-
-        $admin2 = factory(User::class)->create([
-            'email' => 'jane.doe@test.com',
-            'role_id' => $adminRole->id
-        ]);
-
-        $user = factory(User::class)->create([
-            'email' => 'user.doe@test.com',
-            'role_id' => $userRole->id
-        ]);
+        $admin1 = factory(User::class)->create(['email' => 'john.doe@test.com', 'role_id' => $adminRole->id]);
+        $admin2 = factory(User::class)->create(['email' => 'jane.doe@test.com', 'role_id' => $adminRole->id]);
+        $user = factory(User::class)->create(['email' => 'user.doe@test.com', 'role_id' => $userRole->id]);
 
         $data = $this->getRegistrationFormStubData();
         $this->registerUser($data);
 
-        $newUser = User::where('email', $data['email'])->first();
+        Notification::assertSentTo(
+            [$admin1, $admin2],
+            UserRegistered::class,
+            function ($notification) use ($admin1) {
+                $mail = $notification->toMail($admin1)->toArray();
 
-        $inbox = $this->fetchInbox();
+                $this->assertEquals('[foo] New User Registration', $mail['subject']);
 
-        $this->assertEquals(2, count($inbox));
+                $this->assertContains(
+                    trans('app.new_user_was_registered_on', ['app' => settings('app_name')]),
+                    $mail['introLines']
+                );
 
-        $this->assertEquals('[foo] New User Registration', $inbox[0]['subject']);
-        $this->assertEquals('jane.doe@test.com', $inbox[0]['to_email']);
-        $this->assertContains(
-            trans('app.new_user_was_registered_on', ['app' => settings('app_name')]),
-            trim($inbox[0]['html_body'])
-        );
-        $this->assertContains(
-            trans('app.to_view_details_visit_link_below'),
-            trim($inbox[0]['html_body'])
-        );
-        $this->assertContains(
-            route('user.show', $newUser->id),
-            trim($inbox[0]['html_body'])
-        );
+                $this->assertContains(trans('app.to_view_details_visit_link_below'), $mail['introLines']);
 
-        $this->assertEquals('[foo] New User Registration', $inbox[1]['subject']);
-        $this->assertEquals('john.doe@test.com', $inbox[1]['to_email']);
+                return true;
+            }
+        );
 
-        $this->emptyInbox();
+        Notification::assertNotSentTo($user, UserRegistered::class);
     }
 
     public function test_redirect_to_custom_page_after_login()
diff --git a/tests/Feature/Http/Controllers/Web/Auth/PasswordControllerTest.php b/tests/Feature/Http/Controllers/Web/Auth/PasswordControllerTest.php
index 74a44d5..d2f83fc 100644
--- a/tests/Feature/Http/Controllers/Web/Auth/PasswordControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/Auth/PasswordControllerTest.php
@@ -4,23 +4,19 @@ namespace Tests\Feature\Http\Controllers\Web\Auth;
 
 use DB;
 use Hash;
+use Illuminate\Support\Facades\Notification;
 use Illuminate\Support\Str;
 use Mockery;
 use Tests\Feature\FunctionalTestCase;
-use Tests\MailTrap;
-use Portal\Events\User\RequestedPasswordResetEmail;
 use Portal\User;
-use Mockery as m;
 
 class PasswordControllerTest extends FunctionalTestCase
 {
-    use MailTrap;
-
     public function test_send_password_reminder()
     {
-        factory(User::class)->create(['email' => 'test@test.com']);
+        Notification::fake();
 
-        $this->expectsEvents(RequestedPasswordResetEmail::class);
+        $user = factory(User::class)->create(['email' => 'test@test.com']);
 
         $this->visit('password/remind')
             ->type('test@test.com', 'email')
@@ -28,22 +24,18 @@ class PasswordControllerTest extends FunctionalTestCase
             ->seePageIs('password/remind')
             ->see('Password reset email sent. Check your inbox (and spam) folder.');
 
-        $message = $this->fetchInbox()[0];
+        Notification::assertSentTo(
+            $user,
+            \Portal\Notifications\ResetPassword::class,
+            function ($notification) {
+                $mail = $notification->toMail()->toArray();
 
-        $this->assertEquals('test@test.com', $message['to_email']);
-        $this->assertEquals(config('mail.from.address'), $message['from_email']);
-        $this->assertEquals(config('mail.from.name'), $message['from_name']);
-        $this->assertContains(
-            trans('app.request_for_password_reset_made'),
-            $message['html_body']
-        );
+                $this->assertContains(trans('app.request_for_password_reset_made'), $mail['introLines']);
+                $this->assertContains(trans('app.if_you_did_not_requested'), $mail['outroLines']);
 
-        $this->assertContains(
-            trans('app.if_you_did_not_requested'),
-            $message['html_body']
+                return true;
+            }
         );
-
-        $this->emptyInbox();
     }
 
     public function test_password_reminder_with_wrong_email()
diff --git a/tests/Feature/Http/Controllers/Web/Auth/SocialAuthControllerTest.php b/tests/Feature/Http/Controllers/Web/Auth/SocialAuthControllerTest.php
index fbec840..687b6c8 100644
--- a/tests/Feature/Http/Controllers/Web/Auth/SocialAuthControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/Auth/SocialAuthControllerTest.php
@@ -4,7 +4,6 @@ namespace Tests\Feature\Http\Controllers\Web\Auth;
 
 use Auth;
 use DB;
-use Settings;
 use Socialite;
 use Tests\Feature\FunctionalTestCase;
 use Portal\Support\Enum\UserStatus;
diff --git a/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php b/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php
index 7127295..7acaf32 100644
--- a/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php
@@ -183,71 +183,6 @@ class ProfileControllerTest extends FunctionalTestCase
         $this->assertTrue(Hash::check('123123', $user->password));
     }
 
-    public function test_2fa_form_visibility()
-    {
-        config(['services.authy.key' => 'test']);
-
-        $this->setSettings(['2fa.enabled' => false]);
-
-        $this->createAndLoginUser();
-
-        $this->visit("profile")
-            ->dontSee('Two-Factor Authentication');
-
-        $this->setSettings(['2fa.enabled' => true]);
-
-        $this->createAndLoginUser();
-
-        $this->visit("profile")
-            ->see('Two-Factor Authentication');
-    }
-
-    public function test_enable_2fa()
-    {
-        $this->setSettings(['2fa.enabled' => true]);
-
-        $this->user = $this->createAndLoginUser();
-
-        $this->expectsEvents(\Portal\Events\User\TwoFactorEnabled::class);
-
-        Authy::shouldReceive('isEnabled')->andReturn(false);
-        Authy::shouldReceive('register')->andReturnNull();
-
-        $data = ['country_code' => '1', 'phone_number' => '123'];
-
-        $this->visit("profile")
-            ->submitForm('Enable', $data)
-            ->seePageIs("profile")
-            ->seeInDatabase('users', [
-                'id' => $this->user->id,
-                'two_factor_country_code' => $data['country_code'],
-                'two_factor_phone' => $data['phone_number']
-            ])
-            ->see('Two-Factor Authentication enabled successfully.');
-    }
-
-    public function test_disable_2fa()
-    {
-        $this->setSettings(['2fa.enabled' => true]);
-
-        $this->user = $this->createAndLoginUser();
-
-        $this->expectsEvents(\Portal\Events\User\TwoFactorDisabled::class);
-
-        Authy::shouldReceive('isEnabled')->andReturn(true);
-        Authy::shouldReceive('delete')->andReturnNull();
-
-        $this->visit("profile")
-            ->press('Disable')
-            ->seePageIs("profile")
-            ->seeInDatabase('users', [
-                'id' => $this->user->id,
-                'two_factor_country_code' => null,
-                'two_factor_phone' => null
-            ])
-            ->see('Two-Factor Authentication disabled successfully.');
-    }
-
     public function test_activity_log()
     {
         $logger = app(\Portal\Services\Logging\UserActivity\Logger::class);
